NX Open C++ Reference Guide
|
Builder for creating a D-Cubed constrained spline. More...
Public Types | |
enum | SplinePathSlackType { SplinePathSlackTypePercentLength, SplinePathSlackTypeAdditionalLength, SplinePathSlackTypeUndefined } |
Describes the method the spline is defined as. More... | |
Public Member Functions | |
void | AddDefiningPointAtAbsoluteCoords (const NXOpen::Point3d &point) |
Adds a defining point to the spline. | |
int | AddDefiningPointToSpline (NXOpen::Point *point, bool createNewPoint) |
Adds a defining point to the current spline or creates the first point of the new spline. | |
void | AddSlackToSpline (NXOpen::Routing::SplinePathBuilder::SplinePathSlackType slackType, NXOpen::Expression *slackValue, NXOpen::Direction *downDir) |
Created in NX6.0.0. | |
void | AskDefiningData (std::vector< NXOpen::Point * > &points) |
When a spline is selected for editing, the builder will anaylyze the spline and gather all of the defining data. | |
void | AssignExtension (int pointIndex, NXOpen::Direction *direction, NXOpen::Expression *forwardExtVal, NXOpen::Expression *backExtVal) |
Assigns an extension to the point at pointIndex. | |
void | AssignHealPathExtension (int pointIndex, NXOpen::Direction *direction, NXOpen::Expression *forwardExtVal, NXOpen::Expression *backExtVal) |
Assigns an extension to the point at pointIndex for Heal Path. | |
NXOpen::Routing::Stock * | BlankStockAndGetLargestDia () |
Blanks all the stocks on the current segment and returns the stock with the largest diameter. | |
void | CommitDrag (NXOpen::Point *definingPoint) |
Clears the current drag network Created in NX6.0.0. | |
void | DeleteDefiningPointAtIndex (int index) |
Deletes a defining point from the spline. | |
void | DetachPoint (int index) |
Detaches the point at the selected index from all objects its attached to using a Touch constraint. | |
void | GetDefiningPointPositions (std::vector< double > &pointPositions) |
Gets the positions of the defining points. | |
void | GetExtensionDataForPointAtIndex (int index, NXOpen::Expression **forwardVal, NXOpen::Expression **backwardVal, NXOpen::Vector3d *extDir) |
Get the extension expressions at the given index. | |
double | GetLockedSplineMinimumLength () |
Returns the minimum length of the spline. | |
void | GetOffsetData (int index, int *method, NXOpen::Point **basePoint, NXOpen::Direction **offDir, NXString *exp) |
Returns the Stock Offset data associated with a given point. | |
NXOpen::Curve * | GetRouteSegment () |
Gets the routing segment managed by the builder, if it exists. | |
double | GetSplineLength () |
Gets the current length of the spline. | |
double | GetSplineLengthNoShaping () |
Gets the current length of the spline without shaping applied. | |
NXOpen::Routing::ControlPoint * | GetStartAndEndRcp (NXOpen::Routing::ControlPoint **startRcp) |
Gets the RCPs managed by the builder, if they exist. | |
void | InitializeDrag (int index) |
Initialize the D-Cubed dragging functionality for the point at index. | |
void | IsLengthLocked (NXOpen::Expression **lockedLengthVal, bool *isLocked, NXOpen::Direction **downDir) |
Created in NX6.0.0. | |
void | IsSplineSlacked (bool *slacked, NXOpen::Routing::SplinePathBuilder::SplinePathSlackType *slackType, NXOpen::Expression **slackValue, NXOpen::Direction **downDir) |
Created in NX6.0.0. | |
void | LockSplineLengthNoShaping (NXOpen::Expression *length) |
Locks the length of the current spline. | |
void | LockSplineLengthWithShaping (NXOpen::Expression *length, NXOpen::Direction *downDirection) |
Locks the length of the current spline. | |
void | RemoveAllShaping () |
Removes all shaping applied to the spline (Lock length, slacking). | |
void | SetAddPointsOnSubdivideFlag (bool addPoints) |
Sets whether or not additional points will be added to a spline which is created as the result of a subdivide. | |
void | SetCreateTangencyFlag (bool createTangency) |
Sets whether or not additional the newly created spline will be made tangent to connecting splines. | |
void | SetLockToSelectedFlag (bool lockSelected) |
Sets whether the spline will attempt to lock points to selected object. | |
void | SetSplineMethod (NXOpen::Positioning::Constraint::SplineType sMethod) |
Sets the splines method to points or poles. | |
void | UnblankStocks () |
Unblanks stocks which were blanked by calling BlankStockAndGetLargestDia Created in NX7.5.1. | |
void | UpdateDefiningPointPositionAtIndex (int index, NXOpen::Point *point, bool inDrag) |
Updates the position of a point on the spline. | |
![]() | |
NXOpen::NXObject * | Commit () |
Commits any edits that have been applied to the builder. | |
void | Destroy () |
Deletes the builder, and cleans up any objects created by the builder. | |
std::vector< NXOpen::NXObject * > | GetCommittedObjects () |
For builders that create more than one object, this method returns the objects that are created by commit. | |
NXOpen::NXObject * | GetObject () |
Returns the object currently being edited by this builder. | |
void | ShowResults () |
Updates the model to reflect the result of an edit to the model for all builders that support showing results. | |
virtual bool | Validate () |
Validate whether the inputs to the component are sufficient for commit to be called. | |
![]() | |
tag_t | GetTag () const |
<b>Deprecated</b>:<br> Use Tag instead. | |
tag_t | Tag () const |
Returns the tag of this object. | |
Builder for creating a D-Cubed constrained spline.
The builder allows for the creation of splines, editing of splines, adding extensions, adding stock offset points, adding stock, locking length, adding slack, and locking to objects.
To create a new instance of this class, use Routing::RouteManager::CreateSplinePathBuilder
Created in NX6.0.0.
void NXOpen::Routing::SplinePathBuilder::AddDefiningPointAtAbsoluteCoords | ( | const NXOpen::Point3d & | point | ) |
Adds a defining point to the spline.
The new point will be the new endpoint of the spline.
Created in NX6.0.0.
License requirements : routing_base ("Routing Basic")
point | Point to add. |
int NXOpen::Routing::SplinePathBuilder::AddDefiningPointToSpline | ( | NXOpen::Point * | point, |
bool | createNewPoint | ||
) |
Adds a defining point to the current spline or creates the first point of the new spline.
point | Point to add. |
createNewPoint | Should the builder create a new point based on the one provided. |
void NXOpen::Routing::SplinePathBuilder::AddSlackToSpline | ( | NXOpen::Routing::SplinePathBuilder::SplinePathSlackType | slackType, |
NXOpen::Expression * | slackValue, | ||
NXOpen::Direction * | downDir | ||
) |
Created in NX6.0.0.
License requirements : routing_base ("Routing Basic")
slackType | slacktype |
slackValue | slackvalue |
downDir | downdir |
void NXOpen::Routing::SplinePathBuilder::AskDefiningData | ( | std::vector< NXOpen::Point * > & | points | ) |
When a spline is selected for editing, the builder will anaylyze the spline and gather all of the defining data.
The dialog will use this function to retrieve the defining data from the builder to populate its fields.
Created in NX6.0.0.
License requirements : routing_base ("Routing Basic")
points | Defining points of the spline. |
void NXOpen::Routing::SplinePathBuilder::AssignExtension | ( | int | pointIndex, |
NXOpen::Direction * | direction, | ||
NXOpen::Expression * | forwardExtVal, | ||
NXOpen::Expression * | backExtVal | ||
) |
Assigns an extension to the point at pointIndex.
Created in NX6.0.0.
License requirements : routing_base ("Routing Basic")
pointIndex | Index of the point to assing extensions to. |
direction | Direction of the extension. |
forwardExtVal | Length of the forward extension. |
backExtVal | Length of the backward extension. |
void NXOpen::Routing::SplinePathBuilder::AssignHealPathExtension | ( | int | pointIndex, |
NXOpen::Direction * | direction, | ||
NXOpen::Expression * | forwardExtVal, | ||
NXOpen::Expression * | backExtVal | ||
) |
Assigns an extension to the point at pointIndex for Heal Path.
Created in NX6.0.1.
License requirements : routing_base ("Routing Basic")
pointIndex | Index of the point to assing extensions to. |
direction | Direction of the extension. |
forwardExtVal | Length of the forward extension. |
backExtVal | Length of the backward extension. |
NXOpen::Routing::Stock* NXOpen::Routing::SplinePathBuilder::BlankStockAndGetLargestDia | ( | ) |
Blanks all the stocks on the current segment and returns the stock with the largest diameter.
void NXOpen::Routing::SplinePathBuilder::CommitDrag | ( | NXOpen::Point * | definingPoint | ) |
Clears the current drag network
Created in NX6.0.0.
License requirements : routing_base ("Routing Basic")
definingPoint | Optional of UI point defining the position of the spline point. |
void NXOpen::Routing::SplinePathBuilder::DeleteDefiningPointAtIndex | ( | int | index | ) |
Deletes a defining point from the spline.
Created in NX6.0.0.
License requirements : routing_base ("Routing Basic")
index | Index of the point to delete. |
void NXOpen::Routing::SplinePathBuilder::DetachPoint | ( | int | index | ) |
Detaches the point at the selected index from all objects its attached to using a Touch constraint.
Created in NX6.0.0.
License requirements : routing_base ("Routing Basic")
index | Index of point to detach. |
void NXOpen::Routing::SplinePathBuilder::GetDefiningPointPositions | ( | std::vector< double > & | pointPositions | ) |
Gets the positions of the defining points.
Created in NX6.0.0.
License requirements : routing_base ("Routing Basic")
pointPositions | array of doubles representing the defining points. |
void NXOpen::Routing::SplinePathBuilder::GetExtensionDataForPointAtIndex | ( | int | index, |
NXOpen::Expression ** | forwardVal, | ||
NXOpen::Expression ** | backwardVal, | ||
NXOpen::Vector3d * | extDir | ||
) |
Get the extension expressions at the given index.
Created in NX6.0.0.
License requirements : routing_base ("Routing Basic")
index | Index of hte point to anaylze |
forwardVal | Forward Extension Length. |
backwardVal | Backward Extension Length. |
extDir | Extension direction. |
double NXOpen::Routing::SplinePathBuilder::GetLockedSplineMinimumLength | ( | ) |
Returns the minimum length of the spline.
The minimum length is the straight line distance between all defining points, including extensions.
void NXOpen::Routing::SplinePathBuilder::GetOffsetData | ( | int | index, |
int * | method, | ||
NXOpen::Point ** | basePoint, | ||
NXOpen::Direction ** | offDir, | ||
NXString * | exp | ||
) |
NXOpen::Curve* NXOpen::Routing::SplinePathBuilder::GetRouteSegment | ( | ) |
Gets the routing segment managed by the builder, if it exists.
double NXOpen::Routing::SplinePathBuilder::GetSplineLength | ( | ) |
Gets the current length of the spline.
double NXOpen::Routing::SplinePathBuilder::GetSplineLengthNoShaping | ( | ) |
Gets the current length of the spline without shaping applied.
NXOpen::Routing::ControlPoint* NXOpen::Routing::SplinePathBuilder::GetStartAndEndRcp | ( | NXOpen::Routing::ControlPoint ** | startRcp | ) |
Gets the RCPs managed by the builder, if they exist.
startRcp | Segment Start Rcp. |
void NXOpen::Routing::SplinePathBuilder::InitializeDrag | ( | int | index | ) |
Initialize the D-Cubed dragging functionality for the point at index.
Created in NX6.0.0.
License requirements : routing_base ("Routing Basic")
index | Index of the point to drag |
void NXOpen::Routing::SplinePathBuilder::IsLengthLocked | ( | NXOpen::Expression ** | lockedLengthVal, |
bool * | isLocked, | ||
NXOpen::Direction ** | downDir | ||
) |
Created in NX6.0.0.
License requirements : routing_base ("Routing Basic")
lockedLengthVal | lockedlengthval |
isLocked | islocked |
downDir | downdir |
void NXOpen::Routing::SplinePathBuilder::IsSplineSlacked | ( | bool * | slacked, |
NXOpen::Routing::SplinePathBuilder::SplinePathSlackType * | slackType, | ||
NXOpen::Expression ** | slackValue, | ||
NXOpen::Direction ** | downDir | ||
) |
Created in NX6.0.0.
License requirements : routing_base ("Routing Basic")
slacked | slacked |
slackType | slacktype |
slackValue | slackvalue |
downDir | downdir |
void NXOpen::Routing::SplinePathBuilder::LockSplineLengthNoShaping | ( | NXOpen::Expression * | length | ) |
Locks the length of the current spline.
Created in NX6.0.0.
License requirements : routing_base ("Routing Basic")
length | Expression containing the desired length. |
void NXOpen::Routing::SplinePathBuilder::LockSplineLengthWithShaping | ( | NXOpen::Expression * | length, |
NXOpen::Direction * | downDirection | ||
) |
Locks the length of the current spline.
Created in NX6.0.0.
License requirements : routing_base ("Routing Basic")
length | The length to lock the spline to. |
downDirection | downdirection |
void NXOpen::Routing::SplinePathBuilder::RemoveAllShaping | ( | ) |
Removes all shaping applied to the spline (Lock length, slacking).
Created in NX6.0.0.
License requirements : routing_base ("Routing Basic")
void NXOpen::Routing::SplinePathBuilder::SetAddPointsOnSubdivideFlag | ( | bool | addPoints | ) |
Sets whether or not additional points will be added to a spline which is created as the result of a subdivide.
If true, new points will be added to maintain a shape similar to the original curve.
Created in NX6.0.0.
License requirements : routing_base ("Routing Basic")
addPoints | True to add points to subdivided splines. |
void NXOpen::Routing::SplinePathBuilder::SetCreateTangencyFlag | ( | bool | createTangency | ) |
Sets whether or not additional the newly created spline will be made tangent to connecting splines.
Created in NX6.0.0.
License requirements : routing_base ("Routing Basic")
createTangency | True to add tangency. |
void NXOpen::Routing::SplinePathBuilder::SetLockToSelectedFlag | ( | bool | lockSelected | ) |
Sets whether the spline will attempt to lock points to selected object.
This flag is only checked when adding a point to a spline by passing in a smart point to derive a new dumb spline point from. If the smart point is derived from a port, rcp, or other routing object the new spline defining point will lock to that object. This flag is also checked during commit, where endpoint associativity is applied.
Created in NX6.0.0.
License requirements : routing_base ("Routing Basic")
lockSelected | True to lock to selected objects. |
void NXOpen::Routing::SplinePathBuilder::SetSplineMethod | ( | NXOpen::Positioning::Constraint::SplineType | sMethod | ) |
Sets the splines method to points or poles.
Created in NX6.0.0.
License requirements : routing_base ("Routing Basic")
sMethod | Set the defining method of the spline. |
void NXOpen::Routing::SplinePathBuilder::UnblankStocks | ( | ) |
Unblanks stocks which were blanked by calling BlankStockAndGetLargestDia
Created in NX7.5.1.
License requirements : routing_base ("Routing Basic")
void NXOpen::Routing::SplinePathBuilder::UpdateDefiningPointPositionAtIndex | ( | int | index, |
NXOpen::Point * | point, | ||
bool | inDrag | ||
) |
Updates the position of a point on the spline.
Created in NX6.0.0.
License requirements : routing_base ("Routing Basic")
index | The index in the list of defining spline points to move. |
point | Point representing the new position. |
inDrag | True if the point is currently being dragged. |